# Il sito web di Ubuntu-it

Questo repository contiene tutto il codice sorgente del [sito web][1] di
ubuntu-it. Il tutto è rilasciato sotto licenza GNU-AGPL v3+.

Il sito è realizzato con [flask](http://flask.pocoo.org) e Python 3.

## Esecuzione del sito in locale

Per eseguire il sito in locale, è possibile eseguire questo comando (una volta
dentro il virtualenv o con il sito installato globalmente):

```
$ uitwww run -d -p 8000
```

Esso avvierà un'istanza in debug-mode (*da non eseguire in produzione!!!*), che
ascolta su `localhost:8000`. Se si vuole attivare anche la cache statica,
bisogna aggiungere come argomento il path della directory che la dovrà
contenere:

```
$ uitwww run -d -p 8000 path/to/cache
```

## Generazione di una build

Per creare una build dell'intero sito, è necessario disporre di Python 3,
[virtualenv][2], [pyinvoke][3] e nodejs. Dopo averli installati si può crearla
con il seguente comando:

```
$ invoke build
```

Esso scaricherà tutte le dipendenze da internet (la prima volta), compilerà gli
assets e genererà il pacchetto, salvandolo in ``build/packages``. È possibile
rimuovere tutti i file creati dal processo con il comando:

```
$ invoke clean
```

## Hacking

Per preparare l'ambiente di sviluppo è necessario disporre di Python 3,
[virtualenv][2], [pyinvoke][3] e nodejs. Dopo averli installati si può
generarlo con il seguente comando:

```
$ invoke devel
```

Esso scaricherà tutte le dipendenze da internet (la prima volta), compilerà gli
assets e creerà un virtualenv con dentro installato il sito (in modalità
modificabile). Per attivare il virtualenv, bisogna dare in ogni sessione di
terminale il seguente comando:

```
$ source build/envs/devel/bin/activate
```

Se si modificano gli assets è necessario ricompilarli. Lo si può effettuare con
il seguente comando:

```
$ invoke assets
```

In caso si facciano modifiche frequenti, può risultare conveniente l'aggiunta
della flag `-w` al comando, che ricompila gli assets quando sono rilevate
modifiche.

[1]: http://www.ubuntu-it.org
[2]: https://virtualenv.pypa.io
[3]: http://www.pyinvoke.org
